'FFSubmenu=Drucken
'FFName=Print With Filename

' ################################
' Script zum Drucken von
' Bildern mit Dateinamen und Pfad
' --------------------------------
' Print With Filename V1.0.1
' (c) 11.05.2004 BHorn
' --------------------------------
' mit Genehmigung von BHorn ergnzt um Auswahldialog
' Print With Filename V2.0.0 vom 18.05.2008
' Version 2.0.1	vom 15.05.2010	- Textdruck erhlt Abstand zum Bild
' Version 2.0.2	vom 15.05.2010	- Duck wahlweise auch ohne Text mglich
' (c) Harald Maeckler, Dsseldorf 2008
' ################################

Option Explicit

Dim Antwort, x, intPics, bolOK
Dim objFS, WshShell, objFolder, objsubfolder, objFile, Bild
Dim AuswahlWert, Auswahl(2), Anzahl, Gesamtanzahl, DruckODN
Const BildKenn = "BMP-JP2-JPG-PNG-TIF"	'Bildfilter

'** Start Dialog Print with Filename **
FF_AddDialog "Print with Filename",115,76
FF_AddControl "Print with Filename","Auswahl","GROUP",5,5,104,40
FF_AddControl "Print with Filename","selBilder","BOOL",9,15,9,8
FF_SetControlStyle "Print with Filename","selBilder",16384
FF_AddControl "Print with Filename","selektierte Bilder","STATIC",20,14,64,10
FF_AddControl "Print with Filename","allBilder","BOOL",9,25,8,8
FF_SetControlStyle "Print with Filename","allBilder",16384
FF_AddControl "Print with Filename","alle Bilder im Verzeichnis","STATIC",20,24,64,10
FF_AddControl "Print with Filename","allBilderUV","BOOL",9,35,8,8
FF_SetControlStyle "Print with Filename","allBilderUV",16384
FF_AddControl "Print with Filename","alle Bilder incl. Unterverzeichnisse","STATIC",20,34,84,10
FF_AddControl "Print with Filename","DruckODN","BOOL",9,49,8,8
FF_AddControl "Print with Filename","... doch besser ohne Dateiname","STATIC",20,48,84,10
FF_AddControl "Print with Filename","?","BUTTON",8,63,10,10
FF_AddControl "Print with Filename","Abbrechen","BUTTON",34,62,33,11
FF_AddControl "Print with Filename","Drucken","BUTTON",72,62,33,11
'** End Dialog Print with Filename **

call Main

'------------------------------------------------------------------------
Sub Main

Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

call RegistryLesen

do
	Select Case FF_ShowDialog ("Print with Filename")
	Case "selBilder"
		FF_SetControl "Print with Filename","selBilder","1"
		FF_SetControl "Print with Filename","allBilder","0"
		FF_SetControl "Print with Filename","allBilderUV","0"
	Case "allBilder"
		FF_SetControl "Print with Filename","selBilder","0"
		FF_SetControl "Print with Filename","allBilder","1"
		FF_SetControl "Print with Filename","allBilderUV","0"
	Case "allBilderUV"
		FF_SetControl "Print with Filename","selBilder","0"
		FF_SetControl "Print with Filename","allBilder","0"
		FF_SetControl "Print with Filename","allBilderUV","1"
	Case "?"
		msgbox "Die ausgewhlten Bilder werden wahlweise mit oder" & vbNewLine & "ohne ihren Dateinamen ausgedruckt.",,"Erluterung"
	Case "Abbrechen", "CANCEL"
		call RegistrySchreiben
		FF_CloseDialog ("Print with Filename")	
		exit sub
	Case "Drucken"
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Print with Filename")

'Version 2.75.64 abfragen
if not version_equal_or_better("2.75.64") then
	Antwort = msgbox("Erst ab Version 2.75 Build 64 ist die Anpassung von Hoch- und Querformat mglich." & _
			   vbNewLine & "FixFoto sollte unbedingt upgedatet werden!",vbOkCancel,"Meldung")
	if Antwort = vbCancel then exit sub
	bolOK = False
else
	bolOK = True
end if

'### Bilder nacheinander laden
'Auswahl(): 0 = selekt., 1 = alle, 2 = alle inc. UVz.

Set objFolder = objFS.GetFolder(FF_GetImagePath())				'aktiver Ordner

if Auswahl(0) = "1" then										'selektierte Bilder
	intPics = FF_GetImageCount

	if intPics = 0 then
		Antwort = msgbox("Es wurde kein(e) Bild(er) ausgewhlt." & vbNewLine & _
		"Es werden alle Bilder ausgedruckt (ohne Uvz.).",vbOkCancel or vbQuestion,"Abfrage")
		if Antwort = vbCancel then 
			exit sub
		else
			Auswahl(0) = "0"	'selekt. Bilder
			Auswahl(1) = "1"	'alle Bilder
		end if
	end if
end if

call BilderAnzahl	'Bestimmung der Dateienanzahl fr die Fortschrittsanzeige
'Msgbox Gesamtanzahl & " Bilder"

'Filtereintrge 
'Filter = split(NamensFilter,vbNewLine)

'Schleife
If FF_SelectPrinter() then						'Druckerauswahl
	if Auswahl(0) = "1" then					'selektierte Bilder
		For x=0 to intPics - 1	'Bildzhler
			Bild = FF_GetImagename(x)
			Anzahl = Anzahl + 1
			FF_SetProgressText Anzahl, Gesamtanzahl, Bild	'Fortschrittsanzeige
			call Druckausgabe
		next
	else										'alle Bilder exclus. und incl. Untervz.
		call ShowSubfolder (objFolder,0)
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_Print_with_Filename

'Werte auslesen
AuswahlWert = FF_GetProfile("FF_Print_with_Filename","Auswahl")
if AuswahlWert = "" then AuswahlWert = "1/0/0"

DruckODN  = FF_GetProfile("FF_Print_with_Filename","DruckODN")
if DruckODN = "" then DruckODN = 0

'Werte eintragen
AuswahlWert = split(AuswahlWert,"/",-1)
FF_SetControl "Print with Filename","selBilder",AuswahlWert(0)
FF_SetControl "Print with Filename","allBilder",AuswahlWert(1)
FF_SetControl "Print with Filename","allBilderUV",AuswahlWert(2)
FF_SetControl "Print with Filename","DruckODN",DruckODN

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_Print_with_Filename

Auswahl(0) = FF_GetControl("Print with Filename","selBilder")
Auswahl(1) = FF_GetControl("Print with Filename","allBilder")
Auswahl(2) = FF_GetControl("Print with Filename","allBilderUV")
FF_WriteProfile "FF_Print_with_Filename","Auswahl",Auswahl(0) & "/" & Auswahl(1) & "/" & Auswahl(2)

DruckODN = FF_GetControl("Print with Filename","DruckODN")
FF_WriteProfile "FF_Print_with_Filename","DruckODN",DruckODN

End Sub
'------------------------------------------------------------------------
Function version_equal_or_better(p_Vers)
Dim VersNr

VersNr=split(p_Vers,".")
version_equal_or_better=(FF_GetMajor*1000+FF_GetMinor+FF_GetBuild/1000>=_
     VersNr(0)*1000+VersNr(1)+VersNr(2)/1000)

End Function
'------------------------------------------------------------------------
Sub ShowSubfolder(ByVal myfolder,ByVal Tiefe)
'Ausdruck der Bilder in den Unterordnern
Dim strExt

if Auswahl(1) = "1" and Tiefe = 0 or Auswahl(2) = "1" then	
	'*** Ermittlung aller Dateien  des Ordners
	For Each Bild In myfolder.Files
			
		Anzahl = Anzahl + 1
		FF_SetProgressText Anzahl, Gesamtanzahl, Bild	'Fortschrittsanzeige
			
		strExt = objFS.GetExtensionName(Bild.Name) 		'Datei-Extension ermitteln
		
		if instr(Ucase(BildKenn), Ucase(strExt)) > 0 then
			call Druckausgabe
		end if
	next

end if

For Each objsubfolder In myfolder.subfolders
	ShowSubfolder objSubFolder, Tiefe + 1
Next
	
End Sub
'------------------------------------------------------------------------
Sub BilderAnzahl
'Ermittlung der Gesamtanzahl Bilder

if Auswahl(0) = "1" then 
	Gesamtanzahl = intPics
elseif Auswahl(1) = "1" then
	Gesamtanzahl = objFolder.files.count
elseif Auswahl(2) = "1" then
	ZaehlerSub (objFolder)
end if

End Sub
'------------------------------------------------------------------------
Sub ZaehlerSub(ByVal myfolder)
'Zhlen der Ordner, Unterordner und Dateien

'SubAnzahl = SubAnzahl + 1							'Anzahl Ordner incl. Hauptverz.
Gesamtanzahl = Gesamtanzahl + myfolder.files.count	'Anzahl Dateien

For Each objSubFolder In myfolder.subfolders
     ZaehlerSub (objSubFolder)
Next

End sub
'------------------------------------------------------------------------
Sub Druckausgabe

Dim dblHeight, dblWidth
Dim intPicWidth, intPicHeight
Dim intPageWidth, intPageHeight
Dim intTextHeight
Dim xscal, Yscal, scal

'msgbox Bild : exit sub				'Test

' Bild laden
FF_LoadImage Bild

' Breite & Hhe des Bildes
intPicWidth = FF_GetImageWidth() 
intPicHeight = FF_GetImageHeight() 

If bolOK Then						'Version >= 2.75 B64
	If intPicWidth > intPicHeight Then
		FF_PrintLandscape(True)		
	Else
		FF_PrintLandscape(False)		
	End If
End if

' Drucker vorbereiten
FF_StartPrintPage()
		
' Texthhe berechnen
intTextheight = FF_GetPrintTextHeight(Bild, 0.1 * FF_GetPrinterPixelperInchX , 400, False, False, "Arial")
' Breite & Hhe des Druckbereichs
' Texthhe muss abgezogen werden
intPageWidth = FF_GetPrintablePixelX()		
'intPageHeight = FF_GetPrintablePixelY()' - intTextheight		'### gendert ab 2.0.1
if DruckODN = 1 then
	intPageHeight = FF_GetPrintablePixelY()
else
	intPageHeight = FF_GetPrintablePixelY() - 3 * intTextheight
end if															'### bis hierhin

' Scale ausrechnen:
xscal = intPageWidth / intPicWidth
yscal = intPageHeight / intPicHeight
		
if xscal < yscal then 
	scal = xscal
else 
	scal = yscal 
end if
		
' Format mit scal berechnen
intPicHeight = intPicHeight * scal 
intPicWidth = intPicWidth * scal

' Bild auf Drucker
FF_PrintImage 0, 0, intPicWidth, intPicHeight 
' Text auf Drucker
'FF_PrintText Bild, 0, intPicHeight, intTextHeight, 0, 400, False, False, "Arial", 0	'### gendert ab 2.0.1
if DruckODN = 0 then
	FF_PrintText Bild, intTextHeight, intTextHeight + intPicHeight, intTextHeight, 0, 400, False, False, "Arial", 0
end if																					'### bis hierhin
' ... und drucken
FF_EndPrintPage()

End Sub 
'------------------------------------------------------------------------
